/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//-----------------------------------------------------------------------------
// Object: manages the about dialog
//-----------------------------------------------------------------------------

#pragma once

#include <windows.h>
#include <windowsx.h>

#include "resource.h"
#include "../Tools/GUI/SysLink/SysLink.h"
#include "../Tools/GUI/Dialog/DialogHelper.h"
#include "../Tools/Version/Version.h"
#include "../Tools/File/StdFileOperations.h"

#define ID_ABOUT_SYSLINK 10001

#define ABOUT_SYSLINK_TEXT _T("For more information, see the <A ID=\"IdHomePage\">project homepage</A>\r\nor <A ID=\"IdUserDoc\">user manual</A>\r\nAuthor : Jacquelin POTIER\r\n               <A ID=\"IdMailto\">jacquelin.potier@free.fr</A>")
#define ABOUT_SYSLINK_PROJECT_LINK _T("http://jacquelin.potier.free.fr/controlcontentsaver/")
#define ABOUT_SYSLINK_PROJECT_USER_DOC_LINK _T("http://jacquelin.potier.free.fr/controlcontentsaver/#documentation_user")
#define ABOUT_SYSLINK_EMAIL_LINK _T("mailto:jacquelin.potier@free.fr")

#define ABOUT_SYSLINK_XPOS 25
#define ABOUT_SYSLINK_YPOS 130
#define ABOUT_SYSLINK_WIDTH 300
#define ABOUT_SYSLINK_HEIGHT 80

#define ABOUT_OPACITY 95
#define ABOUT_FADING_STEP 4

#define ABOUT_TITLE_FONT_HEIGHT 18
#define ABOUT_LINK_FONT_HEIGHT 16

class CAbout
{
public:
    CAbout();
    ~CAbout();
    static void Show(HINSTANCE hInstance,HWND hWndDialog,TCHAR* pSyslinkText);
private:
    HWND hWndDialog;
    HFONT hFontAboutTitle;
    HFONT hFontAboutLink;
    CSysLink* pSysLinkAbout;
    TCHAR* pSyslinkText;
    TCHAR NameAndVersion[MAX_PATH];

    static CAbout* GetAssociatedObject(HWND hWndDialog);
    void OnExit();
    static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

