/*
Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>
Dynamic aspect ratio code Copyright (C) 2004 Jacquelin POTIER <jacquelin.potier@free.fr>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#pragma once


#include <windows.h>
#include <stdio.h>
#include <commctrl.h>
#pragma warning (push)
#pragma warning(disable : 4005)// for '_stprintf' : macro redefinition in tchar.h
#include <TCHAR.h>
#pragma warning (pop)
#include "../tools/GUI/SelectWindow/selectwindow.h"
#include "../tools/Process/CodeInject/CodeInject.h"
#include "../tools/string/ansiunicodeconvert.h"
#include "../Tools/File/StdFileOperations.h"
#include "../Tools/File/TextFile.h"

#include "XMLLikeConvert.h"

#define TXT_FILE_SPLITTER _T("\t")
#define REMOTECTRLCONTENTSAVER_DEFAULT_TEXT_BUFFER_SIZE 512

typedef LRESULT (WINAPI *pfSendMessage)(HWND,UINT,WPARAM,LPARAM);


class CRemoteCtrlContentSaver
{
public:

    enum REMOTECTRLCONTENTSAVER_SAVING_TYPES
    {
        REMOTECTRLCONTENTSAVER_SAVING_TYPE_TXT,
        REMOTECTRLCONTENTSAVER_SAVING_TYPE_XML,
        REMOTECTRLCONTENTSAVER_SAVING_TYPE_HTML
    };

    enum REMOTECTRLCONTENTSAVER_SUPPORTED_CTRL_TYPES
    {
        SUPPORTED_CTRL_UNSUPPORTED=0,
        SUPPORTED_CTRL_LISTVIEW,
        SUPPORTED_CTRL_COMBOBOX,
        SUPPORTED_CTRL_COMBOBOXEX32,
        SUPPORTED_CTRL_LISTBOX,
        SUPPORTED_CTRL_HEADERS,
        SUPPORTED_CTRL_EDIT,
        SUPPORTED_CTRL_EDIT_PASSWORD,
        SUPPORTED_CTRL_TREEVIEW
    };

    CRemoteCtrlContentSaver(HWND AppDialogHandle);
    CRemoteCtrlContentSaver(BOOL bShowMessages);
    ~CRemoteCtrlContentSaver(void);
    CRemoteCtrlContentSaver::REMOTECTRLCONTENTSAVER_SUPPORTED_CTRL_TYPES UpdateControl(CSelectWindow* pSelectWindow);
    BOOL ShowPasswordContent();
    BOOL GetPasswordContent(TCHAR** pszOut);
    BOOL GetTextContent(TCHAR** pszOut);
    BOOL SaveComboBoxContent(TCHAR* pszFileName);
    BOOL SaveComboBoxEx32Content(TCHAR* pszFileName);
    BOOL SaveListBoxContent(TCHAR* pszFileName,BOOL bSelectedItemsOnly);
    BOOL SaveListViewContent(TCHAR* pszFileName,BOOL bSelectedItemsOnly,SIZE_T* pNumColumns,SIZE_T dwNbSelectedColomns);
    BOOL SaveHeaderContent(TCHAR* pszFileName,SIZE_T* pNumColumns,SIZE_T dwNbSelectedColomns);
    BOOL SaveTreeViewContent(TCHAR* pszFileName,BOOL bExpandedOnly,BOOL bSelectedOnly);
    BOOL GetTreeViewSelectedContent(TCHAR** pszOut);
	DWORD GetTargetProcessId();
	HWND GetTargetHandle();
private:
    typedef struct tagDataSendMessage
    {
        // params we want to transmit
        HWND    Hwnd;
        UINT    Msg;
        WPARAM  Wparam;
        LPARAM  Lparam;
        LRESULT Lresult;
        pfSendMessage pSendMessage;
    }DATASENDMESSAGE,*PDATASENDMESSAGE;

    CRemoteCtrlContentSaver::REMOTECTRLCONTENTSAVER_SUPPORTED_CTRL_TYPES ControlType;
    CRemoteCtrlContentSaver::REMOTECTRLCONTENTSAVER_SAVING_TYPES SavingType;

    CSelectWindow* pSelectWindow;
    HWND HwndDialog;
    TCHAR* pszFileName;
    HANDLE hFile;

    BOOL bShowMessages;
    HANDLE hProcess;
    TV_ITEM* pRemoteTreeViewItem;
    TCHAR* pRemoteItemText;
    DWORD TextBufferSize;

    BOOL OpenFile(TCHAR* pszFileName);
    BOOL CloseFile(BOOL bSuccess);

    BOOL SaveHeaderContent(HANDLE hProcess,HWND hHeader,SIZE_T* pNumColumns,SIZE_T NbSelectedColomns);
    BOOL ShouldColumnBeSaved(SIZE_T ColumnNumberToCheck,SIZE_T* pNumColumns,SIZE_T NbSelectedColomns);

    BOOL SaveTreeViewItemContent(HTREEITEM hTreeItem,DWORD ItemDepth,BOOL bExpandedOnly);
    BOOL WriteTreeViewItemContent(HTREEITEM hTreeItem);
    BOOL WriteTreeViewItemFooter();
    BOOL WriteTreeViewItemHeader(DWORD ItemDepth);
    DWORD GetTreeViewItemDepth(HTREEITEM hTreeItem);
    BOOL GetTreeViewItemText(HTREEITEM hTreeItem,TCHAR** pszOut);
    BOOL InitializeGetTreeViewItemText();
    BOOL FreeGetTreeViewItemText();

    void ShowError(TCHAR* psz);
    void CommonConstructor();

    friend static DWORD WINAPI SendMessageThreadProc (PDATASENDMESSAGE lpParameter);
};
